_G.NXWSMenu = _G.NXWSMenu or {}
NXWSMenu._cfg_path = SavePath .. "noxaudio_settings.txt"
NXWSMenu._data_path = SavePath .. "noxaudio_weapons_ids.txt"
NXWSMenu._cfg = {}
NXWSMenu._data = {}
NXWSMenu._path = ModPath
nxws_default_whitelist = {"ar18","amr12","ak5s","x_ak5s","x_car9","sg416","beck","car9","smolak","x_smolak","cold","x_cold"}
function NXWSMenu:Save()
	local config = io.open(self._cfg_path, "w+")
	local wpnids = io.open(self._data_path, "w+")
	if config then
		config:write(json.encode(self._cfg))
		config:close()
	end
	if wpnids then
		wpnids:write(json.encode(self._data))
		wpnids:close()
	end
end
function NXWSMenu:Load()
	local config = io.open(self._cfg_path, "r")
	local wpnids = io.open(self._data_path, "r")
	if config then
		self._cfg = json.decode(config:read("*all"))
		config:close()
	end
	if wpnids then
		self._data = json.decode(wpnids:read("*all"))
		wpnids:close()
	end
end
MenuHelper:LoadFromJsonFile(NXWSMenu._path .. "menu/json.txt", NXWSMenu, NXWSMenu._data)
NXWSMenu:Load()
Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_NXWSMenu", function(menu_manager)
	MenuCallbackHandler.callback_nxws_open_whitelist = function(self, item)
		os.execute('start "" '..NXWSMenu._data_path)
	end
	MenuCallbackHandler.callback_nxws_reset_whitelist = function(self, item)
		NXWSMenu._data = nxws_default_whitelist
		NXWSMenu:Save()
	end
	MenuCallbackHandler.callback_nxws_log_enabled = function(self, item)
		NXWSMenu._cfg.nxws_log_enabled = (item:value() == "on" and true or false)
		NXWSMenu:Save()
	end
end)
if next(NXWSMenu._data) == nil then
	NXWSMenu._data = nxws_default_whitelist
	NXWSMenu:Save()
end
Hooks:PostHook(WeaponTweakData, "init", "NXWSInit", function(self)
for _, wpn_id in pairs(NXWSMenu._data) do
	if self[wpn_id] then
		self[wpn_id].nxws_whitelisted = true
	end
end
-- Manually corrected weapons for loaded soundbank.
if self.r0991 then
	self.r0991.nxws_bnkID = "new_m4"
end
if self.coltsmg then
	self.coltsmg.nxws_bnkID = "new_m4"
end
if self.l1a1 then
	self.l1a1.nxws_bnkID = "new_m14"
end
if self.mpx then
	self.mpx.nxws_bnkID = "new_m14"
end
if self.aps then
	self.aps.nxws_bnkID = "glock_18c"
end
if self.m60e4 then
	self.m60e4.nxws_bnkID = "m60"
end
--
for _, weap in pairs(self) do
	if weap.animations and weap.sounds and weap.custom == true and not weap.hidden == true and not weap.nxws_whitelisted then
		if weap.animations.reload_name_id then
			reload_ID = weap.animations.reload_name_id
			based_on_ID = weap.based_on
			wpn_ID = weap.name_id
			if weap.sounds.reload and NXWSMenu._cfg.nxws_log_enabled == true then
				log("[NXWS] Reload sounds removed: " .. wpn_ID)
			end
			if self[reload_ID] and self[reload_ID].sounds then
				if weap.nxws_bnkID then
					reload_ID = weap.nxws_bnkID
				end
				weap.sounds = deep_clone(self[reload_ID].sounds)
				if NXWSMenu._cfg.nxws_log_enabled == true then
					log("[NXWS] Changed weapon sounds: " .. wpn_ID .. " to " .. reload_ID)
				end
			elseif not self[reload_ID] and self[based_on_ID] and self[based_on_ID].sounds then
				weap.sounds = deep_clone(self[based_on_ID].sounds)
				if NXWSMenu._cfg.nxws_log_enabled == true then
					log("[NXWS] Changed weapon sounds: " .. wpn_ID .. " to " .. based_on_ID)
				end
			else
				if NXWSMenu._cfg.nxws_log_enabled == true then
					log("[ERROR] NXWS: Sound table not found for: " .. wpn_ID)
				end
			end
		end
	end
end
end)